glibmm 2.38.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::Settings Class Reference

A high-level API for application settings. More...

`#include <giomm/settings.h>`

Inheritance diagram for Gio::Settings:
[legend]

## Public Member Functions
virtual | ~Settings ()
GSettings* | gobj ()
| Provides access to the underlying C GObject. More...
const GSettings* | gobj () const
| Provides access to the underlying C GObject. More...
GSettings* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | set_value (const Glib::ustring& key, const Glib::VariantBase&value)
| Sets key in settings to value. More...
void | get_value (const Glib::ustring& key, Glib::VariantBase&value) const
| Gets the value that is stored in the settings for a key. More...
int | get_int (const Glib::ustring& key) const
| Gets the value that is stored at key in settings. More...
void | set_int (const Glib::ustring& key, int value)
| Sets key in settings to value. More...
guint | get_uint (const Glib::ustring& key) const
| Gets the value that is stored at key in settings. More...
void | set_uiint (const Glib::ustring& key, guint value)
| Sets key in settings to value. More...
bool | get_boolean (const Glib::ustring& key) const
| Gets the value that is stored at key in settings. More...
void | set_boolean (const Glib::ustring& key, bool value)
| Sets key in settings to value. More...
Glib::ustring | get_string (const Glib::ustring& key) const
| Gets the value that is stored at key in settings. More...
void | set_string (const Glib::ustring& key, const Glib::ustring&value)
| Sets key in settings to value. More...
double | get_double (const Glib::ustring& key) const
| Gets the value that is stored at key in settings. More...
void | set_double (const Glib::ustring& key, double value)
| Sets key in settings to value. More...
Glib::StringArrayHandle | get_string_array (const Glib::ustring& key) const
| A convenience variant of g_settings_get() for string arrays. More...
bool | set_string_array (const Glib::ustring& key, const Glib::StringArrayHandle&value)
| Sets key in settings to value. More...
int | get_enum (const Glib::ustring& key) const
| Gets the value that is stored in settings for key and converts it to the enum value that it represents. More...
bool | get_enum (const Glib::ustring& key, int value)
| Looks up the enumerated type nick for value and writes it to key, within settings. More...
guint | get_flags (const Glib::ustring& key) const
| Gets the value that is stored in settings for key and converts it to the flags value that it represents. More...
bool | get_flags (const Glib::ustring& key, guint value)
| Looks up the flags type nicks for the bits specified by value, puts them in an array of strings and writes the array to key, within settings. More...
Glib::RefPtr< Settings > | get_child (const Glib::ustring& name)
| Creates a 'child' settings object which has a base path of base-path/ name, where base-path is the base path of settings. More...
Glib::RefPtr< const Settings > | get_child (const Glib::ustring& name) const
| Creates a 'child' settings object which has a base path of base-path/ name, where base-path is the base path of settings. More...
bool | is_writable (const Glib::ustring& key) const
| Finds out if a key can be written or not. More...
void | delay ()
| Changes the Settings object into 'delay-apply' mode. More...
void | apply ()
| Applies any changes that have been made to the settings. More...
void | revert ()
| Reverts all non-applied changes to the settings. More...
bool | get_has_unapplied () const
| Returns whether the Settings object has any unapplied changes. More...
void | reset (const Glib::ustring& key)
| Resets key to its default value. More...
std::vector< Glib::ustring > | list_children () const
| Gets the list of children on settings. More...
std::vector< Glib::ustring > | list_keys () const
| Introspects the list of keys on settings. More...
bool | range_check (const Glib::ustring& key, const Glib::VariantBase&value) const
| Checks if the given value is of the correct type and within the permitted range for key. More...
void | bind (const Glib::ustring& key, Glib::ObjectBase* object, const Glib::ustring& property, SettingsBindFlags flags=SETTINGS_BIND_DEFAULT)
| Create a binding between the key in the settings object and the property property of object. More...
void | bind (const Glib::ustring& key, const Glib::PropertyProxy_Base& property_proxy, SettingsBindFlags flags=SETTINGS_BIND_DEFAULT)
void | bind_writable (const Glib::ustring& key, Glib::ObjectBase* object, const Glib::ustring& property, bool inverted=false)
| Create a binding between the writability of key in the settings object and the property property of object. More...
void | bind_writable (const Glib::ustring& key, const Glib::PropertyProxy_Base& property_proxy, bool inverted=false)
Glib::RefPtr< Action > | create_action (const Glib::ustring& key)
| Creates a Action corresponding to a given Settings key. More...
Glib::PropertyProxy_ReadOnly < bool > | property_delay_apply () const
| Whether this settings object is in 'delay-apply' mode. More...
Glib::PropertyProxy_ReadOnly < bool > | property_has_unapplied () const
| TRUE if there are outstanding changes to apply(). More...
Glib::PropertyProxy_ReadOnly < std::string > | property_path () const
| The path within the backend where the settings are. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_schema () const
| The name of the schema for this settings object. More...
Glib::PropertyProxy_ReadOnly < Glib::ustring > | property_schema_id () const
| The name of the schema for this settings object. More...
Glib::SignalProxy1< void, const Glib::ustring& > | signal_changed ()
Glib::SignalProxy1< bool, guint > | signal_writable_change_event ()
Glib::SignalProxy1< void, const Glib::ustring& > | signal_writable_changed ()
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Settings > | create (const Glib::ustring& schema)
static Glib::RefPtr< Settings > | create (const Glib::ustring& schema, const Glib::ustring& path)
static std::vector< Glib::ustring > | list_schemas ()
| Gets a list of the Settings schemas installed on the system. More...

## Protected Member Functions
| Settings (const Glib::ustring& schema)
| Settings (const Glib::ustring& schema, const Glib::ustring& path)
virtual void | on_changed (const Glib::ustring& key)
| This is a default handler for the signal signal_changed(). More...
virtual bool | on_writable_change_event (guint key)
| This is a default handler for the signal signal_writable_change_event(). More...
virtual void | on_writable_changed (const Glib::ustring& key)
| This is a default handler for the signal signal_writable_changed(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::Settings > | wrap (GSettings* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)

## Detailed Description

A high-level API for application settings.

The Settings class provides a convenient API for storing and retrieving application settings.

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::Settings::~Settings | ( |  | ) |
| virtual

Gio::Settings::Settings | ( | const Glib::ustring& | schema | ) |
| explicit protected

Gio::Settings::Settings | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | path
| ) |  |
| explicit protected

## Member Function Documentation

void Gio::Settings::apply | ( |  | ) |

Applies any changes that have been made to the settings.

This function does nothing unless settings is in 'delay-apply' mode; see g_settings_delay(). In the normal case settings are always applied immediately.

void Gio::Settings::bind | ( | const Glib::ustring& | key,
|  | Glib::ObjectBase* | object,
|  | const Glib::ustring& | property,
|  | SettingsBindFlags | flags = `SETTINGS_BIND_DEFAULT`
| ) |  |

Create a binding between the key in the settings object and the property property of object.

The binding uses the default GIO mapping functions to map between the settings and property values. These functions handle booleans, numeric types and string types in a straightforward way. Use g_settings_bind_with_mapping() if you need a custom mapping, or map between types that are not supported by the default mapping functions.

Unless the flags include SETTINGS_BIND_NO_SENSITIVITY, this function also establishes a binding between the writability of key and the "sensitive" property of object (if object has a boolean property by that name). See g_settings_bind_writable() for more details about writable bindings.

Note that the lifecycle of the binding is tied to the object, and that you can have only one binding per object property. If you bind the same property twice on the same object, the second binding overrides the first one.

Since glibmm 2.26:

Parameters

  key | The key to bind.
  object | A Object.
  property | The name of the property to bind.
  flags | Flags for the binding.

void Gio::Settings::bind | ( | const Glib::ustring& | key,
|  | const Glib::PropertyProxy_Base& | property_proxy,
|  | SettingsBindFlags | flags = `SETTINGS_BIND_DEFAULT`
| ) |  |

void Gio::Settings::bind_writable | ( | const Glib::ustring& | key,
|  | Glib::ObjectBase* | object,
|  | const Glib::ustring& | property,
|  | bool | inverted = `false`
| ) |  |

Create a binding between the writability of key in the settings object and the property property of object.

The property must be boolean; "sensitive" or "visible" properties of widgets are the most likely candidates.

Writable bindings are always uni-directional; changes of the writability of the setting will be propagated to the object property, not the other way.

When the inverted argument is `true`, the binding inverts the value as it passes from the setting to the object, i.e. property will be set to `true` if the key is not writable.

Note that the lifecycle of the binding is tied to the object, and that you can have only one binding per object property. If you bind the same property twice on the same object, the second binding overrides the first one.

Since glibmm 2.26:

Parameters

  key | The key to bind.
  object | A Object.
  property | The name of a boolean property to bind.
  inverted | Whether to 'invert' the value.

void Gio::Settings::bind_writable | ( | const Glib::ustring& | key,
|  | const Glib::PropertyProxy_Base& | property_proxy,
|  | bool | inverted = `false`
| ) |  |

static Glib::RefPtr<Settings> Gio::Settings::create | ( | const Glib::ustring& | schema | ) |
| static

static Glib::RefPtr<Settings> Gio::Settings::create | ( | const Glib::ustring& | schema,
|  | const Glib::ustring& | path
| ) |  |
| static

Glib::RefPtr<Action> Gio::Settings::create_action | ( | const Glib::ustring& | key | ) |

Creates a Action corresponding to a given Settings key.

The action has the same name as the key.

The value of the key becomes the state of the action and the action is enabled when the key is writable. Changing the state of the action results in the key being written to. Changes to the value or writability of the key cause appropriate change notifications to be emitted for the action.

For boolean-valued keys, action activations take no parameter and result in the toggling of the value. For all other types, activations take the new value for the key (which must have the correct type).

Since glibmm 2.32:

Parameters

  key | The name of a key in settings.

Returns
  A new Action.

void Gio::Settings::delay | ( |  | ) |

Changes the Settings object into 'delay-apply' mode.

In this mode, changes to settings are not immediately propagated to the backend, but kept locally until g_settings_apply() is called.

Since glibmm 2.26:

bool Gio::Settings::get_boolean | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for booleans.

It is a programmer error to give a key that isn't specified as having a boolean type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  A boolean.

Glib::RefPtr<Settings> Gio::Settings::get_child | ( | const Glib::ustring& | name | ) |

Creates a 'child' settings object which has a base path of base-path/ name, where base-path is the base path of settings.

The schema for the child settings object must have been declared in the schema of settings using a <tag class="starttag">child</tag> element.

Since glibmm 2.26:

Parameters

  name | The name of the 'child' schema.

Returns
  A 'child' settings object.

Glib::RefPtr<const Settings> Gio::Settings::get_child | ( | const Glib::ustring& | name | ) | const

Creates a 'child' settings object which has a base path of base-path/ name, where base-path is the base path of settings.

The schema for the child settings object must have been declared in the schema of settings using a <tag class="starttag">child</tag> element.

Since glibmm 2.26:

Parameters

  name | The name of the 'child' schema.

Returns
  A 'child' settings object.

double Gio::Settings::get_double | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for doubles.

It is a programmer error to give a key that isn't specified as having a 'double' type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  A double.

int Gio::Settings::get_enum | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored in settings for key and converts it to the enum value that it represents.

In order to use this function the type of the value must be a string and it must be marked in the schema file as an enumerated type.

It is a programmer error to give a key that isn't contained in the schema for settings or is not marked as an enumerated type.

If the value stored in the configuration database is not a valid value for the enumerated type then this function will return the default value.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  The enum value.

bool Gio::Settings::get_enum | ( | const Glib::ustring& | key,
|  | int | value
| ) |  |

Looks up the enumerated type nick for value and writes it to key, within settings.

It is a programmer error to give a key that isn't contained in the schema for settings or is not marked as an enumerated type, or for value not to be a valid value for the named type.

After performing the write, accessing key directly with g_settings_get_string() will return the 'nick' associated with value.

Parameters

  key | A key, within settings.
  value | An enumerated value.

Returns
  `true`, if the set succeeds.

guint Gio::Settings::get_flags | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored in settings for key and converts it to the flags value that it represents.

In order to use this function the type of the value must be an array of strings and it must be marked in the schema file as an flags type.

It is a programmer error to give a key that isn't contained in the schema for settings or is not marked as a flags type.

If the value stored in the configuration database is not a valid value for the flags type then this function will return the default value.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  The flags value.

bool Gio::Settings::get_flags | ( | const Glib::ustring& | key,
|  | guint | value
| ) |  |

Looks up the flags type nicks for the bits specified by value, puts them in an array of strings and writes the array to key, within settings.

It is a programmer error to give a key that isn't contained in the schema for settings or is not marked as a flags type, or for value to contain any bits that are not value for the named type.

After performing the write, accessing key directly with g_settings_get_strv() will return an array of 'nicks'; one for each bit in value.

Parameters

  key | A key, within settings.
  value | A flags value.

Returns
  `true`, if the set succeeds.

bool Gio::Settings::get_has_unapplied | ( |  | ) | const

Returns whether the Settings object has any unapplied changes.

This can only be the case if it is in 'delayed-apply' mode.

Since glibmm 2.26:

Returns
  `true` if settings has unapplied changes.

int Gio::Settings::get_int | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for 32-bit integers.

It is a programmer error to give a key that isn't specified as having a int32 type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  An integer.

Glib::ustring Gio::Settings::get_string | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for strings.

It is a programmer error to give a key that isn't specified as having a string type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  A newly-allocated string.

Glib::StringArrayHandle Gio::Settings::get_string_array | ( | const Glib::ustring& | key | ) | const

A convenience variant of g_settings_get() for string arrays.

It is a programmer error to give a key that isn't specified as having an array of strings type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The key to get the value for.

Returns
  A newly-allocated, `0`-terminated array of strings, the value that is stored at key in settings.

static GType Gio::Settings::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

guint Gio::Settings::get_uint | ( | const Glib::ustring& | key | ) | const

Gets the value that is stored at key in settings.

A convenience variant of g_settings_get() for 32-bit unsigned integers.

It is a programmer error to give a key that isn't specified as having a uint32 type in the schema for settings.

Since glibmm 2.30:

Parameters

  key | The key to get the value for.

Returns
  An unsigned integer.

void Gio::Settings::get_value | ( | const Glib::ustring& | key,
|  | Glib::VariantBase& | value
| ) |  | const

Gets the value that is stored in the settings for a key.

It is a programmer error to give a key that isn't contained in the schema for the settings.

Parameters

  key | The key to get the value for.
  value | A Variant of the expected type.

Since glibmm 2.28:

GSettings* Gio::Settings::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GSettings* Gio::Settings::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GSettings* Gio::Settings::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::Settings::is_writable | ( | const Glib::ustring& | key | ) | const

Finds out if a key can be written or not.

Since glibmm 2.26:

Parameters

  name | The name of a key.

Returns
  `true` if the key name is writable.

std::vector<Glib::ustring> Gio::Settings::list_children | ( |  | ) | const

Gets the list of children on settings.

The list is exactly the list of strings for which it is not an error to call g_settings_get_child().

For GSettings objects that are lists, this value can change at any time and you should connect to the "children-changed" signal to watch for those changes. Note that there is a race condition here: you may request a child after listing it only for it to have been destroyed in the meantime. For this reason, g_settings_get_child() may return `0` even for a child that was listed by this function.

For GSettings objects that are not lists, you should probably not be calling this function from "normal" code (since you should already know what children are in your schema). This function may still be useful there for introspection reasons, however.

You should free the return value with Glib::strfreev() when you are done with it.

Returns
  A list of the children on settings.

std::vector<Glib::ustring> Gio::Settings::list_keys | ( |  | ) | const

Introspects the list of keys on settings.

You should probably not be calling this function from "normal" code (since you should already know what keys are in your schema). This function is intended for introspection reasons.

You should free the return value with Glib::strfreev() when you are done with it.

Returns
  A list of the keys on settings.

static std::vector<Glib::ustring> Gio::Settings::list_schemas | ( |  | ) |
| static

Gets a list of the Settings schemas installed on the system.

The returned list is exactly the list of schemas for which you may call g_settings_new() without adverse effects.

This function does not list the schemas that do not provide their own paths (ie: schemas for which you must use g_settings_new_with_path()). See g_settings_list_relocatable_schemas() for that.

Since glibmm 2.26:

Returns
  A list of Settings schemas that are available. The list must not be modified or freed.

virtual void Gio::Settings::on_changed | ( | const Glib::ustring& | key | ) |
| protected virtual

This is a default handler for the signal signal_changed().

virtual bool Gio::Settings::on_writable_change_event | ( | guint | key | ) |
| protected virtual

This is a default handler for the signal signal_writable_change_event().

virtual void Gio::Settings::on_writable_changed | ( | const Glib::ustring& | key | ) |
| protected virtual

This is a default handler for the signal signal_writable_changed().

Glib::PropertyProxy_ReadOnly< bool > Gio::Settings::property_delay_apply | ( |  | ) | const

Whether this settings object is in 'delay-apply' mode.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gio::Settings::property_has_unapplied | ( |  | ) | const

TRUE if there are outstanding changes to apply().

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< std::string > Gio::Settings::property_path | ( |  | ) | const

The path within the backend where the settings are.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::Settings::property_schema | ( |  | ) | const

The name of the schema for this settings object.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::Settings::property_schema_id | ( |  | ) | const

The name of the schema for this settings object.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

bool Gio::Settings::range_check | ( | const Glib::ustring& | key,
|  | const Glib::VariantBase& | value
| ) |  | const

Checks if the given value is of the correct type and within the permitted range for key.

This API is not intended to be used by normal programs – they should already know what is permitted by their own schemas. This API is meant to be used by programs such as editors or commandline tools.

It is a programmer error to give a key that isn't contained in the schema for settings.

Since glibmm 2.28:

Parameters

  key | The key to check.
  value | The value to check.

Returns
  `true` if value is valid for key.

void Gio::Settings::reset | ( | const Glib::ustring& | key | ) |

Resets key to its default value.

This call resets the key, as much as possible, to its default value. That might the value specified in the schema or the one set by the administrator.

Parameters

  key | The name of a key.

void Gio::Settings::revert | ( |  | ) |

Reverts all non-applied changes to the settings.

This function does nothing unless settings is in 'delay-apply' mode; see g_settings_delay(). In the normal case settings are always applied immediately.

Change notifications will be emitted for affected keys.

void Gio::Settings::set_boolean | ( | const Glib::ustring& | key,
|  | bool | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for booleans.

It is a programmer error to give a key that isn't specified as having a boolean type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | The value to set it to.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_double | ( | const Glib::ustring& | key,
|  | double | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for doubles.

It is a programmer error to give a key that isn't specified as having a 'double' type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | The value to set it to.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_int | ( | const Glib::ustring& | key,
|  | int | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for 32-bit integers.

It is a programmer error to give a key that isn't specified as having a int32 type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | The value to set it to.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_string | ( | const Glib::ustring& | key,
|  | const Glib::ustring& | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for strings.

It is a programmer error to give a key that isn't specified as having a string type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | The value to set it to.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

bool Gio::Settings::set_string_array | ( | const Glib::ustring& | key,
|  | const Glib::StringArrayHandle& | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for string arrays. If value is `0`, then key is set to be the empty array.

It is a programmer error to give a key that isn't specified as having an array of strings type in the schema for settings.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | The value to set it to, or `0`.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

void Gio::Settings::set_uiint | ( | const Glib::ustring& | key,
|  | guint | value
| ) |  |

Sets key in settings to value.

A convenience variant of g_settings_set() for 32-bit unsigned integers.

It is a programmer error to give a key that isn't specified as having a uint32 type in the schema for settings.

Since glibmm 2.30:

Parameters

  key | The name of the key to set.
  value | The value to set it to.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

bool Gio::Settings::set_value | ( | const Glib::ustring& | key,
|  | const Glib::VariantBase& | value
| ) |  |

Sets key in settings to value.

It is a programmer error to give a key that isn't contained in the schema for settings or for value to have the incorrect type, per the schema.

If value is floating then this function consumes the reference.

Since glibmm 2.26:

Parameters

  key | The name of the key to set.
  value | A Variant of the correct type.

Returns
  `true` if setting the key succeeded, `false` if the key was not writable.

Glib::SignalProxy1< void,const Glib::ustring& > Gio::Settings::signal_changed | ( |  | ) |

Slot Prototype:
  `void on_my_changed(const Glib::ustring& key)`

The "changed" signal is emitted when a key has potentially changed. You should call one of the g_settings_get() calls to check the new value.

This signal supports detailed connections. You can connect to the detailed signal "changed::x" in order to only receive callbacks when key "x" changes.

Parameters

  key | The name of the key that changed.

Glib::SignalProxy1< bool,guint > Gio::Settings::signal_writable_change_event | ( |  | ) |

Slot Prototype:
  `bool on_my_writable_change_event(guint key)`

The "writable-change-event" signal is emitted once per writability change event that affects this settings object. You should connect to this signal if you are interested in viewing groups of changes before they are split out into multiple emissions of the "writable-changed" signal. For most use cases it is more appropriate to use the "writable-changed" signal.

In the event that the writability change applies only to a single key, key will be set to the Quark for that key. In the event that the writability change affects the entire settings object, key will be 0.

The default handler for this signal invokes the "writable-changed" and "changed" signals for each affected key. This is done because changes in writability might also imply changes in value (if for example, a new mandatory setting is introduced). If any other connected handler returns `true` then this default functionality will be suppressed.

Parameters

  key | The quark of the key, or 0.

Returns
  `true` to stop other handlers from being invoked for the event. `false` to propagate the event further.

Glib::SignalProxy1< void,const Glib::ustring& > Gio::Settings::signal_writable_changed | ( |  | ) |

Slot Prototype:
  `void on_my_writable_changed(const Glib::ustring& key)`

The "writable-changed" signal is emitted when the writability of a key has potentially changed. You should call g_settings_is_writable() in order to determine the new status.

This signal supports detailed connections. You can connect to the detailed signal "writable-changed::x" in order to only receive callbacks when the writability of "x" changes.

Parameters

  key | The key.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::Settings > wrap | ( | GSettings * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.